App::Sqitch::Role::TargetConfigCommand(3pm)

Name
App::Sqitch::Role::TargetConfigCommand - A command that handles target-related configuration

Synopsis
  package App::Sqitch::Command::init;
  extends 'App::Sqitch::Command';
  with 'App::Sqitch::Role::TargetConfigCommand';

Description
This role encapsulates the common attributes and methods required by commands that deal with change script configuration, including script directories and extensions.

Interface

  Class Methods
"options"

  my @opts = App::Sqitch::Command::checkout->options;

Adds options common to the commands that manage script configuration.

"configure"

Configures the options common to commands manage script configuration.

  Attributes
"properties"

A hash reference of target configurations. The keys may be as follows:

"deploy"
"revert"
"verify"
"reworked"
"reworked_deploy"
"reworked_revert"
"reworked_verify"
"extension"

  Instance Methods
"config_target"

  my $target = $cmd->config_target;
  my $target = $cmd->config_target(%params);

Constructs a target based on the contents of "properties". The supported parameters are:

"name"
    A target name.

"uri"
    A target URI.

"engine"
    An engine name.

The passed target and engine names take highest precedence, falling back on the properties and the "default_target". All other properties are applied to the target before returning it.

"write_plan"

  $cmd->write_plan(%params);

Writes out the plan file. Supported parameters are:

"target"
    The target for which the plan will be written. Defaults to the target returned by config_target().

"project"
    The project name. If not passed, the project name will be read from the default target's plan, if it exists. Otherwise an error will be thrown.

"uri"
    The project URI. Optional. If not passed, the URI will be read from the default target's plan, if it exists. Optional.

"directories_for"

  my @dirs = $cmd->directories_for(@targets);

Returns a set of script directories for a list of targets. Options passed to the command are preferred. Paths are pulled from the command only when they have not been passed as options.

"make_directories_for"

  $cmd->directories_for(@targets);

Creates script directories for one or more targets. Options passed to the command are preferred. Paths are pulled from the command only when they have not been passed as options.

"mkdirs"

   $cmd->directories_for(@dirs);

Creates the list of directories on the file system. Directories that already exist are skipped. Messages are sent to info() for each directory, and an error is thrown on the first to fail.

"config_params"

  my @params = $cmd->config_params($key);

Returns a list of parameters to pass to the App::Sqitch::Config "set" method, built up from the "properties".

See Also

App::Sqitch::Command::init
    The "init" command initializes a Sqitch project, setting up the change script configuration and directories.

App::Sqitch::Command::engine
    The "engine" command manages engine configuration, including engine-specific change script configuration.

App::Sqitch::Command::target
    The "engine" command manages target configuration, including target-specific change script configuration.

Author
David E. Wheeler <david@justatheory.com>

License
Copyright (c) 2012-2026 David E. Wheeler, 2012-2021 iovation Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.